#include<iostream>
using namespace std;

struct Nyja
{
	int e_dhena;
	char ngjyra;
	Nyja *majtas, *djathtas, *prindi;
};
typedef Nyja *nyjePtr;
nyjePtr rrenja, pri;

class KuqZi
{
	int i, j;
public:
	void shto(nyjePtr &, int x);
	void rregullo(nyjePtr);

	nyjePtr rrotulloMajtas(nyjePtr, nyjePtr);
	nyjePtr rrotulloDjathtas(nyjePtr, nyjePtr);

	void inorder(nyjePtr);
	void postorder(nyjePtr);
	void preorder(nyjePtr);
};

void KuqZi::rregullo(nyjePtr ny)
{
	if (ny->prindi == NULL)
		ny->ngjyra = 'z';
	else if (ny->prindi->ngjyra == 'z')
		return;
	else
	{
		nyjePtr u, d, pr = ny->prindi;
		d = ny->prindi->prindi;
		
		if (pr == d->majtas)
			u = d->djathtas;
		else
			u = d->majtas;
		
		if (u != NULL && u->ngjyra == 'k')
		{
			pr->ngjyra = 'z';
			u->ngjyra = 'z';
			d->ngjyra = 'k';
			rregullo(d);
		}
		else
		{
			if (ny == pr->djathtas && pr == d->majtas)
			{
				pr = rrotulloMajtas(pr, ny);
				ny = ny->majtas;
			}
			else if (ny == pr->majtas && pr == d->djathtas)
			{
				pr = rrotulloDjathtas(pr, ny);
				ny = ny->djathtas;
			}
			pr = ny->prindi;
			pr->ngjyra = 'z';
			d->ngjyra = 'k';
			
			if (ny == pr->majtas)
				d = rrotulloDjathtas(d, d->majtas);
			else
				d = rrotulloMajtas(d, d->djathtas);
		}
	}
}

nyjePtr KuqZi::rrotulloDjathtas(nyjePtr p, nyjePtr q)
{
	nyjePtr r = p;
	p->majtas = q->djathtas;

	if (q->djathtas != NULL)
		q->djathtas->prindi = p;

	q->djathtas = p;
	q->prindi = p->prindi;
	p->prindi = q;

	if (q->prindi != NULL)
	{
		if (q->e_dhena<q->prindi->e_dhena)
			q->prindi->majtas = q;
		else
			q->prindi->djathtas = q;
	}

	if (r == rrenja)
		rrenja = q;
	return q;
}

nyjePtr KuqZi::rrotulloMajtas(nyjePtr p, nyjePtr q)
{
	nyjePtr r = p;
	p->djathtas = q->majtas;

	if (q->majtas != NULL)
		q->majtas->prindi = p;

	q->majtas = p;
	q->prindi = p->prindi;
	p->prindi = q;

	if (q->prindi != NULL)
	{
		if (q->e_dhena<q->prindi->e_dhena)
			q->prindi->majtas = q;
		else
			q->prindi->djathtas = q;
	}

	if (r == rrenja)
		rrenja = q;
	return q;
}

void KuqZi::shto(nyjePtr &n, int vlera)
{
	if (n == NULL)
	{
		n = new Nyja;
		n->e_dhena = vlera;
		n->majtas = NULL;
		n->djathtas = NULL;
		n->ngjyra = 'k';
		n->prindi = pri;
		rregullo(n);
	}
	else if (vlera<n->e_dhena)
	{
		pri = n;
		shto(n->majtas, vlera);
	}
	else if (vlera>n->e_dhena)
	{
		pri = n;
		shto(n->djathtas, vlera);
	}
	else
		cout << "\ne_dhena ekziston";
}

void KuqZi::inorder(nyjePtr p)
{
	if (p != NULL)
	{
		inorder(p->majtas);
		cout << endl << p->e_dhena << " " << p->ngjyra;
		inorder(p->djathtas);
	}
}

void KuqZi::preorder(nyjePtr n)
{
	if (n)
	{
		cout << endl << n->e_dhena << " " << n->ngjyra;
		preorder(n->majtas);
		preorder(n->djathtas);
	}
}

void KuqZi::postorder(nyjePtr n)
{
	if (n)
	{
		postorder(n->majtas);
		postorder(n->djathtas);
		cout << endl << n->e_dhena << " " << n->ngjyra;
	}
}

int main()
{
	rrenja = pri = NULL;
	KuqZi a;
	a.shto(rrenja,14);
	a.shto(rrenja,8);
	a.shto(rrenja,1);
	a.shto(rrenja,6);
	a.shto(rrenja,9);
	a.shto(rrenja,16);
	a.shto(rrenja,15);
	a.shto(rrenja,25);
	a.shto(rrenja,22);
	a.shto(rrenja,27);
	
	cout << "In order\n";
	a.inorder(rrenja);

	cout << "\nPre order\n";
	a.preorder(rrenja);

	system("pause");
	return 0;
}